//identity function, λ a → a
var id = new Lambda("a", new Variable("a"))

//example1: (λ b → (λ a → b a)) (λ a → a), should evaluate to (λ a → a)
new Application(new Lambda("b", new Lambda("a", new Application(new Variable("b"), new Variable("a")))), new Lambda("a", new Variable("a"))).reduce().toString()

//example2: (λ b → (λ a → b a)) a, should introduce a fresh variable and evaluate to (λ tmpX → a tmpX)
new Application(new Lambda("b", new Lambda("a", new Application(new Variable("b"), new Variable("a")))), new Variable("a")).reduce().toString()

//zero - the number zero, in church encoding λ f → (λ x → x)
var z = new Lambda("f", new Lambda("x", new Variable("x")))
//successor function for natural church numbers -  λ n → (λ f → (λ x → f (n f x)))
var succ = new Lambda("n", new Lambda("f", new Lambda("x", new Application(new Variable("f"), new Application(new Application(new Variable("n"), new Variable("f")), new Variable("x"))))))

//successor new Applicationlied to zero - result is one: λ f → (λ x → f x)
// (λ n → λ f → λ x → (f) (((n) (f)) (x))) (λ f → λ x → x)
new Application(new Lambda("n", new Lambda("f", new Lambda("x", new Application(new Variable("f"), new Application(new Application(new Variable("n"), new Variable("f")), new Variable("x")))))), new Lambda("f", new Lambda("x", new Variable("x")))).reduce().toString()
//same thing: λ f → (λ x → f x)
new Application(succ, z).reduce().toString()

//plus is just m times new Applicationlication of f to n
// λ m → (λ n → (λ f → (λ x → m f (n f x))))
var plus = new Lambda("m", new Lambda("n", new Lambda("f", new Lambda("x", new Application(new Application(new Variable("m"), new Variable("f")), new Application(new Application(new Variable("n"), new Variable("f")), new Variable("x")))))))

//which is the very same as m times succ
// λ m → (λ n → m SUCC n)
var plusp = new Lambda("m", new Lambda("n", new Application(new Variable("m"), new Application(succ, new Variable("n")))))

//multiplication is m ^ n f new Applicationlied
// λ m → (λ n → (λ f → m (n f)))

//multiplying m and n is the same as repeating the add n function m times and then new Applicationlying it to zero
// λ m → (λ n → m (PLUS n) 0)

//predecessor
// λ n → (λ f → (λ x → n (λ g → (λ h → h (g f))) (λ u → x) (λ u → u)

//subtraction
// λ m → (λ n → (n pred) m)


//a test if a number is zero
//prerequisite is false and true...
// λ n → n (λ x → F) T




//pairs - a pair is (x, y) - so two values.
//valuable functions are: construction, first and second projection

// pair = λ x → (λ y → (λ z → z x y))
// fst = λ p → p (λ x → λ y → x)
// snd = λ p → p (λ x → λ y → y)


//lists - a cons contains head and tail -- so the very same as a pair!
// cons = pair
// head = fst
// tail = snd
// nil = F
// isnil = λ l → l (λ h → λ t → λ d → F) T

//where the last definition is a special case of the general (foldl!)
// process-list = λ l → l (λ h → λ t → λ d → head-and-tail-clause) nil-clause

//church booleans
//true: λ w → (λ f → w)
var wahr = new Lambda("w", new Lambda("f", new Variable("w")))
//false: λ w → (λ f → f)
var falsch = new Lambda("w", new Lambda("f", new Variable("f")))
//the logical and: λ p → (λ q → p q p)
var and = new Lambda("p", new Lambda("q", new Application(new Application(new Variable("p"), new Variable("q")), new Variable("p"))))

//t & t = t
new Application(new Application(and, t), t).reduce().toString()
//t & f = f
new Application(new Application(and, t), f).reduce().toString()
//f & t = f
new Application(new Application(and, f), t).reduce().toString()
//f & f = f
new Application(new Application(and, f), f).reduce().toString()

//we can also partially new Applicationly and evaluate that!
//t & _ = t --> λ q → q
new Application(and, t).reduce().toString()

//logical or: λ p → (λ q → p p q)
var or = new Lambda("p", new Lambda("q", new Application(new Application(new Variable("p"), new Variable("p")), new Variable("q"))))
//partial - voila da ist es irrelevant, was als q gegeben wird!
var ort = new Application(or, t).reduce().toString()
//und hier kommt das q was reingegeben wird, einfach zurueck!
var orf = new Application(or, f).reduce().toString()

//conditional - gets a predicate p, executes a if true, otherwise b!
//IFTHENELSE = λ p → λ a → λ b → p a b

//U combinator
//λ f → f (f)

//Y combinator
//λ g → (λ x → g (x x)) (λ x → g (x x))

//S K I - vielleicht

